package currentweek.android.uoc.edu.aliapp;

import android.content.Context;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Toast;

import static currentweek.android.uoc.edu.aliapp.MainActivity.session;

public class AreaNoviosActivity extends AppCompatActivity {

    private static final String TIPO_LISTA = "TIPO_LISTA";
    private static final String ALIANZA = "ALIANZA";
    private static final String PEDIDA = "PEDIDA";



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_seccion_novios);

        // Permitir botón atrás
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        // Colocar título a la ventana
        getSupportActionBar().setTitle("Área de novios");
    }


    public static Intent makeIntent(Context context) {
        return new Intent(context, AreaNoviosActivity.class);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_superior, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {
            case android.R.id.home: //hago un case por si en un futuro agrego mas opciones
                Log.i("ActionBar", "Atrás!");
                finish();
                return true;

            case R.id.action_settings:
                session.setLogin(false);
                Toast.makeText(this, R.string.cerrar_sesion, Toast.LENGTH_SHORT).show();
                Log.d("sesion", "Cerrando sesión...");

                Intent intent = MainActivity.makeIntent(this);
                startActivity(intent);
                finish();
                return true;

            case R.id.action_settings_favoritos:
                Log.d("favoritos", "Ver favoritos");

                Intent i = FavoritosActivity.makeIntent(this);
                startActivity(i);
                return true;

            case R.id.action_settings_home:
                Intent goHome = MainActivity.makeIntent(this);
                startActivity(goHome);
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }

    }


    public void irTiraRamo(View view) {
        Intent intent = TiraTuRamoActivity.makeIntent(this);
        startActivity(intent);
    }


    public void irCatalogoPedida(View view) {
        Intent intent = ArticuloActivity.makeIntent(this);
        intent.putExtra(TIPO_LISTA, PEDIDA);
        startActivity(intent);
    }


    public void irCatalogoAlianzas(View view) {
        Intent intent = ArticuloActivity.makeIntent(this);
        intent.putExtra(TIPO_LISTA, ALIANZA);
        startActivity(intent);
    }

    public void irJuegaEnPareja(View view) {
        Intent intent = JuegaEnParejaInfoActivity.makeIntent(this);
        startActivity(intent);
    }

    public void irConfigurador(View view) {
        Intent intent = DisenaTuJoyaInfoActivity.makeIntent(this);
        startActivity(intent);
    }


}
