package currentweek.android.uoc.edu.aliapp;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.os.Debug;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.os.Bundle;
import android.support.v7.widget.StaggeredGridLayoutManager;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.squareup.picasso.Picasso;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.security.PrivilegedAction;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;

import model.AppConfig;
import model.AppController;
import model.Producto;
import model.SQLiteHandler;

import static currentweek.android.uoc.edu.aliapp.MainActivity.session;
import static model.AppConfig.DEFAULT_URL;

public class ArticuloActivity extends AppCompatActivity {

    private static final String TAG = "Articulo Área Novios";
    private static final String TIPO_LISTA = "TIPO_LISTA";
    private static final String ALIANZA = "ALIANZA";
    private static final String PEDIDA = "PEDIDA";

    private static final String PELO = "ARTÍCULOS DE PELO";
    private static final String COLGANTES = "COLGANTES";
    private static final String PULSERAS = "PULSERAS";
    private static final String GEMELOS = "GEMELOS";
    private static final String PINZA = "PINZA DE CORBATA";
    private static final String PENDIENTES = "PENDIENTES";

    // Relojes
    private static final String MONT_BLANC = "MONT BLANC";
    private static final String GUCCI = "GUCCI";
    private static final String TISSOT = "TISSOT";
    private static final String SWAROVSKI = "SWAROVSKI";
    private static final String JAGUAR = "JAGUAR";
    private static final String MICHAEL_KORS = "MICHAEL KORS";

    private static final String CALVIN_KLEIN = "CALVIN KLEIN";
    private static final String FOSSIL = "FOSSIL";
    private static final String SKAGEN = "SKAGEN";
    private static final String FESTINA = "FESTINA";
    private static final String LOTUS = "LOTUS";
    private static final String VICEROY = "VICEROY";

    private static final String CASIO = "CASIO";
    private static final String CALYPSO = "CALYPSO";
    private static final String SANDOZ = "SANDOZ";
    private static final String EMPORIO_ARMANI = "EMPORIO ARMANI";
    private static final String ARMANI_EXCHANGE = "ARMANI EXCHANGE";
    private static final String GARMIN = "GARMIN";


    private String categoria;

    private String tipoLista;

    private RecyclerView recyclerView;
    private SimpleItemRecyclerViewAdapter adapter = null;
    private TextView sinStockLbl;

    private boolean sinStock = false;



    public static List<Producto> listaProductos;

    private Context context;

    private SQLiteHandler db;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_articulo);

        // Habilitar botón atrás
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);


        listaProductos = new ArrayList<Producto>();

        recyclerView = (RecyclerView) findViewById(R.id.listaArticulos);

        sinStockLbl = findViewById(R.id.lblSinStock);



        context = this.getApplicationContext();


        Intent intent = getIntent();
        Bundle bundle = intent.getExtras();

        // Dependiendo de lo que se le pasa al intent, obtendrá unos artículos u otros
        if (bundle != null) {
            tipoLista = (String) bundle.get(TIPO_LISTA);

            Log.d("tipo recibido", tipoLista);

            // Cargar lista de productos
            switch (tipoLista) {
                case ALIANZA:
                    categoria = "alianza";
                    break;

                case PEDIDA:
                    categoria = "pedida";
                    break;


                case PELO:
                    categoria = "pelo";
                    break;


                case COLGANTES:
                    Log.d("tipo recibido", "colgante");
                    categoria = "colgante";
                    break;

                case PULSERAS:
                    categoria = "pulsera";
                    break;

                case GEMELOS:
                    categoria = "gemelo";
                    break;

                case PINZA:
                    categoria = "pinza";
                    break;

                case PENDIENTES:
                    categoria = "pendientes";
                    break;

                default:
                    Log.d("tipo lista relojes", "tipo lista" + tipoLista);
                    if (tipoLista.equals(MONT_BLANC) ||tipoLista.equals(GUCCI) || tipoLista.equals(TISSOT) ||
                            tipoLista.equals(SWAROVSKI) || tipoLista.equals(MICHAEL_KORS) || tipoLista.equals(SKAGEN) ||
                            tipoLista.equals(JAGUAR) || tipoLista.equals(VICEROY) || tipoLista.equals(CALVIN_KLEIN) || tipoLista.equals(CALYPSO) ||
                            tipoLista.equals(CASIO) || tipoLista.equals(SANDOZ) || tipoLista.equals(FESTINA) ||
                            tipoLista.equals(FOSSIL) || tipoLista.equals(LOTUS) || tipoLista.equals(EMPORIO_ARMANI) || tipoLista.equals(ARMANI_EXCHANGE) ||
                            tipoLista.equals(GARMIN)) {
                        categoria = tipoLista;
                        Log.d("tipo lista relojes", "tipo lista" + categoria);
                    }
                    else
                        sinStock = true;
                    break;

            }

            // Colocar título a la ventana
            getSupportActionBar().setTitle(tipoLista);

            if (!sinStock) {
                db = new SQLiteHandler(getApplicationContext());
                obtenerProductos(categoria);
                sinStockLbl.setVisibility(View.GONE);
            }
            else  {
                sinStockLbl.setVisibility(View.VISIBLE);
            }
        }

    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_superior, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {
            case android.R.id.home: //hago un case por si en un futuro agrego mas opciones
                Log.i("ActionBar", "Atrás!");
                finish();
                return true;

            case R.id.action_settings:
                session.setLogin(false);
                Toast.makeText(this, R.string.cerrar_sesion, Toast.LENGTH_SHORT).show();
                Log.d("sesion", "Cerrando sesión...");

                Intent intent = MainActivity.makeIntent(this);
                startActivity(intent);
                finish();
                return true;

            case R.id.action_settings_favoritos:
                Log.d("favoritos", "Ver favoritos");

                Intent i = FavoritosActivity.makeIntent(this);
                startActivity(i);
                return true;

            case R.id.action_settings_home:
                Intent goHome = MainActivity.makeIntent(this);
                startActivity(goHome);
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }

    }


    public static Intent makeIntent(Context context) {
        return new Intent(context, ArticuloActivity.class);
    }


    private void inicializarLista() {
        adapter = new SimpleItemRecyclerViewAdapter(listaProductos);

        recyclerView.setLayoutManager(new StaggeredGridLayoutManager(3, LinearLayoutManager.VERTICAL));
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.setAdapter(adapter);



    }

    private  void cargarLista(JSONArray jArray) {

try{

            for (int i = 0; i < jArray.length(); i++) {
                JSONObject json_data = null;

                json_data = jArray.getJSONObject(i);


                String name = json_data.getString("name");
                if (name == "null")
                    name = "";

                String id =json_data.getString("id_product");
                String description =json_data.getString("description");
                if (description == "null")
                    description = "";

                String material = json_data.getString("material");
                if (material == "null")
                    material = "";

                String photo = json_data.getString("photo");
                if (photo == "null")
                    photo = "";

                String user = json_data.getString("user");
                if (user == "null")
                    user = "";

                String price = json_data.getString("price");
                if (price == "null")
                    price = "";

                String ref = json_data.getString("reference");
                if (ref == "null")
                    ref = "";

                String min = json_data.getString("min_size");
                if (min == "null")
                    min = "0";

                String max = json_data.getString("max_size");
                if (max == "null")
                    max = "0";

                String quantity = json_data.getString("quantity");
                if (name == "null")
                    name = "1";

                String url = json_data.getString("url");
                if (url == "null")
                    url = DEFAULT_URL;

                listaProductos.add(new Producto(id, name, price, description, categoria, photo, material, min, max, quantity, ref, url));


            }

            inicializarLista();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }



        private void obtenerProductos(final String categoria) {
        String tag_string_req = "req_product";


        StringRequest strReq = new StringRequest(Request.Method.POST,
                AppConfig.URL_PRODUCTS, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {
                Log.d(TAG, "Product Response: " + response.toString());

                try {
                    JSONArray jObj = new JSONArray(response);

                    // comprobar si hay error
                   cargarLista(jObj);
                } catch (JSONException e) {
                    // JSON error
                    e.printStackTrace();

                    sinStockLbl.setVisibility(View.VISIBLE);
                }

            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e(TAG, "Error al obtener productos: " + error.getMessage());
                Toast.makeText(getApplicationContext(),
                        error.getMessage(), Toast.LENGTH_LONG).show();
            }
        }) {

            @Override
            protected Map<String, String> getParams() {
                // Posting parameters to login url
                Map<String, String> params = new HashMap<String, String>();
                params.put("category", categoria);

                return params;
            }

        };

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(strReq, tag_string_req);
    }


    // Diseño lista de alianzas CATALOGO ALIANZAS
    public class SimpleItemRecyclerViewAdapter extends RecyclerView.Adapter<SimpleItemRecyclerViewAdapter.ViewHolder> {

        private List<Producto> mValues;


        public class ViewHolder extends RecyclerView.ViewHolder {
            // Views of each item of the list
            public View mView;
            public ImageView mFoto;


            /*
             * Constructor that defines the views
             * */
            public ViewHolder(View view) {
                super(view);

                mView = view;
                mFoto = (ImageView) view.findViewById(R.id.fotoProducto);

            }

        }


        /*
         * Constructor that loads the list content
         * */
        public SimpleItemRecyclerViewAdapter(List<Producto> myDataset) {
            mValues = myDataset;
        }

        /*
         * We establish the model of each item of the list
         * */
        @NonNull
        @Override
        public SimpleItemRecyclerViewAdapter.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

            View v = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_producto, parent, false);
            ViewHolder vh = new ViewHolder(v);

            return vh;

        }


        /*
         * In each item of the list, we upload the information of a follower
         * */
        @Override
        public void onBindViewHolder(@NonNull SimpleItemRecyclerViewAdapter.ViewHolder holder, final int position) {

            // Set different colors for even and odd cells
            if (position % 2 == 0)
                holder.mView.setBackgroundColor(Color.parseColor("#595959"));
            else
                holder.mView.setBackgroundColor(Color.parseColor("#000000"));



            // Set follower info
            Producto articulo = mValues.get(position);

            String urlFoto = articulo.getFoto();

            if (urlFoto != null && urlFoto != "")
                Picasso.with(context).load(urlFoto).into(holder.mFoto);


            // Colocamos el listener
            holder.mView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {

                Intent i = new Intent(context, DetalleProductoActivity.class);
                i.putExtra(DetalleProductoActivity.CURRENT_POSITION, position + 1);
                startActivity(i);

                }
            });

        }

        @Override
        public int getItemCount() {
            return mValues.size();
        }

    }



    /* getter */
    static public List<Producto> getListaProductos() {
        return listaProductos;
    }


    /* setter */
    public static void setListaProductos(List<Producto> listaProductos) {
        ArticuloActivity.listaProductos = listaProductos;
    }
}