package currentweek.android.uoc.edu.aliapp;

import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Build;
import android.provider.MediaStore;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.squareup.picasso.Picasso;
import com.squareup.picasso.Target;

import java.io.ByteArrayOutputStream;
import java.io.File;

import static currentweek.android.uoc.edu.aliapp.MainActivity.session;

public class DisenaTuJoyaPaso2 extends AppCompatActivity {


    private boolean permisos = false;
    private Context context;

    private RadioGroup modeloRg;
    private RadioGroup formaRg;
    private RadioGroup materialRg;
    private RadioGroup acabadoRg;
    private RadioGroup grosorRg;

    private RadioButton optMatSimple1;
    private RadioButton optMatSimple2;

    private RadioButton optMatDoble1;
    private RadioButton optMatDoble2;
    private RadioButton optMatDoble3;

    private RadioButton optMatTriple1;
    private RadioButton optMatTriple2;
    private RadioButton optMatTriple3;
    private RadioButton optMatTriple4;
    private RadioButton optMatTriple5;

    private RadioButton optAcSimple1;
    private RadioButton optAcSimple2;
    private RadioButton optAcSimple3;

    private RadioButton optAcDobleTriple;

    public static File finalFile;
    public static boolean adjunto = false;


    private ImageView imageView;
    private SeekBar size;
    private TextView lblSize;
    private ImageButton btnCompartir;

    private int sizeAlianza;
    private int rutaImagenActual;

    private int esModelo = 1;


    private Bitmap imageBitmap = null;

    // Request code
    private final int REQUEST_PERMISSION_STORAGE_SAVE = 101;
    private final int REQUEST_TAKE_PHOTO = 110;
    private static final int PERMISO_REQUEST_WRITE_EXTERNAL_STORAGE = 102;

    private boolean variosMateriales = false;




    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_disena_tu_joya);

        context = this.getApplicationContext();


            // Habilitar botón atrás
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);

            // Colocar título a la ventana
            getSupportActionBar().setTitle("Diseña tu joya II");


            imageView = findViewById(R.id.imagenActualDisenio);

            modeloRg = findViewById(R.id.rgModelo);
            formaRg = findViewById(R.id.rgForma);
            materialRg = findViewById(R.id.rgMaterial);
            acabadoRg = findViewById(R.id.rgAcabado);
            grosorRg = findViewById(R.id.rgGrosor);


            // Definir los radiobuttons que varían en función de la configuración
            optMatSimple1 = findViewById(R.id.optMatOB);
            optMatSimple2 = findViewById(R.id.optMatOA);

            optMatDoble1 = findViewById(R.id.optMatOBOA);
            optMatDoble2 = findViewById(R.id.optMatOBOR);
            optMatDoble3 = findViewById(R.id.optMatOBOB);

            optMatTriple1 = findViewById(R.id.optMatABA);
            optMatTriple2 = findViewById(R.id.optMatBAB);
            optMatTriple3 = findViewById(R.id.optMatRBR);
            optMatTriple4 = findViewById(R.id.optMatBRB);
            optMatTriple5 = findViewById(R.id.optMatABR);

            optAcSimple1 = findViewById(R.id.optAc1);
            optAcSimple2 = findViewById(R.id.optAc2);
            optAcSimple3 = findViewById(R.id.optAc3);

            optAcDobleTriple = findViewById(R.id.optAc4);


            lblSize = findViewById(R.id.lblSizePaso2);
            size = findViewById(R.id.sizeSeekBar);

            // por defecto cargar tamaño de pantalla anterior
            // Tamaño
            size.setProgress(MedidorAlianzaActivity.alianza.getMedidaInd());
            int medidaMostrada = MedidorAlianzaActivity.alianza.getMedidaInd() + 8;
            lblSize.setText(getString(R.string.lbl_size) + medidaMostrada  + "");
            sizeAlianza = MedidorAlianzaActivity.alianza.getMedidaInd();

            // Imagen
            rutaImagenActual = R.mipmap.oa_red_sat;
            Picasso.with(context).load(rutaImagenActual).into(imageView);

            // Resto de características
            MedidorAlianzaActivity.alianza.setMaterial("OA");
            materialRg.check(R.id.optMatOA);

            MedidorAlianzaActivity.alianza.setAcabadoSelec("SATINADO");
            acabadoRg.check(R.id.optAc2);

            MedidorAlianzaActivity.alianza.setModelo("PIEZA UNICA");
            modeloRg.check(R.id.optMod1);

            MedidorAlianzaActivity.alianza.setForma("REDONDEADO");
            formaRg.check(R.id.optFor1);

            MedidorAlianzaActivity.alianza.setIndGrosor("STANDARD");
            grosorRg.check(R.id.optGr1);

            opcionesEsSimple();

            size.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {

                int progress = 0;
                @Override
                public void onProgressChanged(SeekBar seekBar, int progresValue, boolean fromUser) {
                    int siz = progresValue + 8;
                    progress = siz;
                    lblSize.setText(getString(R.string.lbl_size) + " " + siz);

                    sizeAlianza = progresValue;
                }

                @Override
                public void onStartTrackingTouch(SeekBar seekBar) {

                }

                @Override
                public void onStopTrackingTouch(SeekBar seekBar) {
                    lblSize.setText(getString(R.string.lbl_size) + " " +  progress);
                }

            });



            modeloRg.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {

                @Override
                public void onCheckedChanged(RadioGroup group, int checkedId) {

                    switch (checkedId) {
                        case R.id.optMod1:
                            MedidorAlianzaActivity.alianza.setModelo("PIEZA UNICA");
                            opcionesEsSimple();
                            break;

                        case R.id.optMod2:
                            MedidorAlianzaActivity.alianza.setModelo("DOS SECCIONES");
                            opcionesEsDoble();
                            break;

                        case R.id.optMod3:
                            MedidorAlianzaActivity.alianza.setModelo("TRES SECCIONES");
                            opcionesEsTriple();
                            break;
                    }

                    actualizarImagen();

                }

            });


            formaRg.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {

                @Override
                public void onCheckedChanged(RadioGroup group, int checkedId) {

                    switch (checkedId) {
                        case R.id.optFor1:
                            MedidorAlianzaActivity.alianza.setForma("REDONDEADO");
                            break;

                        case R.id.optFor2:
                            MedidorAlianzaActivity.alianza.setForma("RECTO");
                            break;
                    }

                    actualizarImagen();
                }

            });


            materialRg.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {

                @Override
                public void onCheckedChanged(RadioGroup group, int checkedId) {

                    switch (checkedId) {
                        case R.id.optMatOB:
                            MedidorAlianzaActivity.alianza.setMaterial("OB");
                            break;

                        case R.id.optMatOA:
                            MedidorAlianzaActivity.alianza.setMaterial("OA");
                            break;

                        case R.id.optMatOBOA:
                            MedidorAlianzaActivity.alianza.setMaterial("OBOA");
                            break;

                        case R.id.optMatOBOR:
                            MedidorAlianzaActivity.alianza.setMaterial("OB");
                            break;

                        case R.id.optMatOBOB:
                            MedidorAlianzaActivity.alianza.setMaterial("OBOB");
                            break;

                        case R.id.optMatABA:
                            MedidorAlianzaActivity.alianza.setMaterial("ABA");
                            break;

                        case R.id.optMatBAB:
                            MedidorAlianzaActivity.alianza.setMaterial("BAB");
                            break;

                        case R.id.optMatBRB:
                            MedidorAlianzaActivity.alianza.setMaterial("BRB");
                            break;

                        case R.id.optMatABR:
                            MedidorAlianzaActivity.alianza.setMaterial("ABR");
                            break;

                        case R.id.optMatRBR:
                            MedidorAlianzaActivity.alianza.setMaterial("RBR");
                            break;
                    }

                    actualizarImagen();
                }

            });


            acabadoRg.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {

                @Override
                public void onCheckedChanged(RadioGroup group, int checkedId) {

                    switch (checkedId) {
                        case R.id.optAc1:
                            MedidorAlianzaActivity.alianza.setAcabadoSelec("PULIDO");
                            break;

                        case R.id.optAc2:
                            MedidorAlianzaActivity.alianza.setAcabadoSelec("SATINADO");
                            break;

                        case R.id.optAc3:
                            MedidorAlianzaActivity.alianza.setAcabadoSelec("DIAMANTADO");
                            break;

                        case R.id.optAc4:
                            MedidorAlianzaActivity.alianza.setAcabadoSelec("SATINADO - PULIDO");
                            break;
                    }

                    actualizarImagen();
                }

            });


            grosorRg.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {

                @Override
                public void onCheckedChanged(RadioGroup group, int checkedId) {

                    switch (checkedId) {
                        case R.id.optGr1:
                            MedidorAlianzaActivity.alianza.setIndGrosor("STANDARD");
                            break;

                        case R.id.optGr2:
                            MedidorAlianzaActivity.alianza.setIndGrosor("MEDIANO");
                            break;

                        case R.id.optGr3:
                            MedidorAlianzaActivity.alianza.setIndGrosor("PREMIUM");
                            break;
                    }

                    actualizarImagen();
                }

            });


            btnCompartir = findViewById(R.id.btnCompartir);
            btnCompartir.setOnClickListener(new View.OnClickListener() {

                public void onClick(View view) {
                    if (permisos)
                        compartirOtrasApps();
                    else
                        preguntarPermisos();
                }
            });


    }



    public void irPaso3(View view) {
        MedidorAlianzaActivity.alianza.setMedidaInd(sizeAlianza);

        Intent intent = DisenaTuJoyaPaso3.makeIntent(this);
        startActivity(intent);
    }


    private void opcionesEsDoble() {
        esModelo = 2;

        optMatSimple1.setVisibility(View.GONE);
        optMatSimple2.setVisibility(View.GONE);

        optMatDoble1.setVisibility(View.VISIBLE);
        optMatDoble2.setVisibility(View.VISIBLE);
        optMatDoble3.setVisibility(View.VISIBLE);

        optMatTriple1.setVisibility(View.GONE);
        optMatTriple2.setVisibility(View.GONE);
        optMatTriple3.setVisibility(View.GONE);
        optMatTriple4.setVisibility(View.GONE);
        optMatTriple5.setVisibility(View.GONE);

        // No hat diamantado doble
        optAcSimple3.setVisibility(View.GONE);
        optAcDobleTriple.setVisibility(View.VISIBLE);
    }



    private void opcionesEsSimple() {
        esModelo = 1;

        optMatSimple1.setVisibility(View.VISIBLE);
        optMatSimple2.setVisibility(View.VISIBLE);

        optMatDoble1.setVisibility(View.GONE);
        optMatDoble2.setVisibility(View.GONE);
        optMatDoble3.setVisibility(View.GONE);

        optMatTriple1.setVisibility(View.GONE);
        optMatTriple2.setVisibility(View.GONE);
        optMatTriple3.setVisibility(View.GONE);
        optMatTriple4.setVisibility(View.GONE);
        optMatTriple5.setVisibility(View.GONE);

        optAcSimple3.setVisibility(View.VISIBLE);
        optAcDobleTriple.setVisibility(View.GONE);
    }



    private void opcionesEsTriple() {
        esModelo = 3;

        optMatSimple1.setVisibility(View.GONE);
        optMatSimple2.setVisibility(View.GONE);

        optMatDoble1.setVisibility(View.GONE);
        optMatDoble2.setVisibility(View.GONE);
        optMatDoble3.setVisibility(View.GONE);

        optMatTriple1.setVisibility(View.VISIBLE);
        optMatTriple2.setVisibility(View.VISIBLE);
        optMatTriple3.setVisibility(View.VISIBLE);
        optMatTriple4.setVisibility(View.VISIBLE);
        optMatTriple5.setVisibility(View.VISIBLE);

        // No hat diamantado triple
        optAcSimple3.setVisibility(View.GONE);
        optAcDobleTriple.setVisibility(View.VISIBLE);

    }


    /**
     * Este método se encargará de modificar la imagen del anillo que
     * se está configurando en función de las características que hay
     * seleccionadas en el momento, con las que se ha creado un objeto
     * de tipo Alianza, para luego poder enviar la información de manera
     * sencilla
     *
     */
    private void actualizarImagen() {


        switch (MedidorAlianzaActivity.alianza.getModelo()) {
            case "PIEZA UNICA":
                switch (MedidorAlianzaActivity.alianza.getMaterial()) {
                    case "OA":
                        if (MedidorAlianzaActivity.alianza.getForma() == "REDONDEADO") {
                            switch (MedidorAlianzaActivity.alianza.getAcabadoSelec()) {
                                case "PULIDO":
                                    rutaImagenActual = R.mipmap.oa_red_pul;
                                    break;

                                case "SATINADO":
                                    rutaImagenActual = R.mipmap.oa_red_sat;
                                    break;

                                case "DIAMANTADO":
                                    rutaImagenActual = R.mipmap.oa_red_diamantado;
                                    break;
                            }
                        } else { // es recto
                            switch (MedidorAlianzaActivity.alianza.getAcabadoSelec()) {
                                case "PULIDO":
                                    rutaImagenActual = R.mipmap.oa_cua_pul;
                                    break;

                                case "SATINADO":
                                    rutaImagenActual = R.mipmap.oa_cua_sat;
                                    break;

                                case "DIAMANTADO":
                                    rutaImagenActual = R.mipmap.oa_cua_diamantado;
                                    break;
                            }
                        }
                        break;


                    case "OB":
                        if (MedidorAlianzaActivity.alianza.getForma() == "REDONDEADO") {
                            switch (MedidorAlianzaActivity.alianza.getAcabadoSelec()) {
                                case "PULIDO":
                                    rutaImagenActual = R.mipmap.ob_cua_pul; // No hay redondo pulido imagen
                                    break;

                                case "SATINADO":
                                    rutaImagenActual = R.mipmap.ob_red_sat_2;
                                    break;

                                case "DIAMANTADO":
                                    rutaImagenActual = R.mipmap.ob_red_diamantado;
                                    break;
                            }
                        } else { // es recto
                            switch (MedidorAlianzaActivity.alianza.getAcabadoSelec()) {
                                case "PULIDO":
                                    rutaImagenActual = R.mipmap.ob_cua_pul;
                                    break;

                                case "SATINADO":
                                    rutaImagenActual = R.mipmap.ob_cua_sat;
                                    break;

                                case "DIAMANTADO":
                                    rutaImagenActual = R.mipmap.ob_cua_dia;
                                    break;
                            }
                        }
                        break;
                }
                break;




            case "DOS SECCIONES":
                // Obviamos la forma y el material porque no hay tantas imágenes de muestra de momento, se ampliarán
                switch (MedidorAlianzaActivity.alianza.getAcabadoSelec()) {
                    case "PULIDO":
                        rutaImagenActual = R.mipmap.bi_duo_pul;
                        break;

                    case "SATINADO":
                        rutaImagenActual = R.mipmap.bi_duo_sat;
                        break;

                    case "DIAMANTADO":
                        rutaImagenActual = R.mipmap.bi_duo_dia;
                        break;

                    case "SATINADO - PULIDO":
                        rutaImagenActual = R.mipmap.bi_duo_satpul;
                        break;
                }
                break;




            case "TRES SECCIONES":
                // Obviamos la forma y el material porque no hay tantas imágenes de muestra de momento, se ampliarán
                switch (MedidorAlianzaActivity.alianza.getAcabadoSelec()) {
                    case "PULIDO":
                        rutaImagenActual = R.mipmap.bi_tri;
                        break;

                    case "SATINADO":
                        rutaImagenActual = R.mipmap.bi_tri_sat;
                        break;

                    case "SATINADO - PULIDO":
                        rutaImagenActual = R.mipmap.bi_tri_sat; // No hay imagen de momento
                        break;
                }
                break;
        }


        // cambiar imagen
        Picasso.with(context).load(rutaImagenActual).into(imageView);

    }



    public static Intent makeIntent(Context context) {
        return new Intent(context, DisenaTuJoyaPaso2.class);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_superior, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {
            case android.R.id.home: //hago un case por si en un futuro agrego mas opciones
                Log.i("ActionBar", "Atrás!");
                finish();
                return true;

            case R.id.action_settings:
                session.setLogin(false);
                Toast.makeText(this, R.string.cerrar_sesion, Toast.LENGTH_SHORT).show();
                Log.d("sesion", "Cerrando sesión...");

                Intent intent = MainActivity.makeIntent(this);
                startActivity(intent);
                finish();
                return true;

            case R.id.action_settings_favoritos:
                Log.d("favoritos", "Ver favoritos");

                Intent i = FavoritosActivity.makeIntent(this);
                startActivity(i);
                return true;

            case R.id.action_settings_home:
                Intent goHome = MainActivity.makeIntent(this);
                startActivity(goHome);
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }

    }



    public void adjuntarImagen(View view) {
        Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);

        // Start activity
        startActivityForResult(intent, REQUEST_TAKE_PHOTO);
    }






    @Override protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        if (requestCode == REQUEST_TAKE_PHOTO) {
            // Obtenemos imagen
            //imageBitmap = (Bitmap) data.getParcelableExtra("data");
            adjunto = true;
            MainActivity.fotoMail = true;

            imageBitmap = (Bitmap) data.getExtras().get("data");
            imageView.setImageBitmap(imageBitmap);


            // CALL THIS METHOD TO GET THE URI FROM THE BITMAP
            Uri tempUri = getImageUri(getApplicationContext(), imageBitmap);

            // CALL THIS METHOD TO GET THE ACTUAL PATH
            finalFile = new File(getRealPathFromURI(tempUri));


            Toast.makeText(this, "La imagen ha sido capturada correctamente", Toast.LENGTH_SHORT).show();
        }

    }


    public void compartirOtrasApps(){
        try {

            Picasso.with(this)
                    .load(rutaImagenActual) // Aquí iría la url de la imagen que se va mostrando
                    .into(new Target() {
                        @Override
                        public void onBitmapLoaded(Bitmap bitmap, Picasso.LoadedFrom from) {
                            // loaded bitmap is here (bitmap)
                            if (bitmap != null) {
                                Uri img = getImageUri(context, bitmap);
                                adjuntarImagen(img);
                            }
                        }

                        @Override
                        public void onBitmapFailed(Drawable errorDrawable) {

                            Intent intent = new Intent();
                            intent.setAction(Intent.ACTION_SEND);

                            // insertamos los datos en el intent y especificamos el tipo
                            intent.putExtra(Intent.EXTRA_TEXT,  getString(R.string.texto_compartir_disenio));
                            intent.setType("text/plain");

                            // Generamos un selector con las aplicaciones disponibles para hacer el envío de información
                            Intent chooser = Intent.createChooser(intent, "Compartir mediante otras aplicaciones");
                            if (intent.resolveActivity(getPackageManager()) != null) {
                                startActivity(chooser);
                            }

                        }

                        @Override
                        public void onPrepareLoad(Drawable placeHolderDrawable) {

                        }
                    });
        } catch (Exception e) {
            Log.d("Detalle", e.toString());
        }
    }


    private Uri getImageUri(Context inContext, Bitmap inImage) {
        ByteArrayOutputStream bytes = new ByteArrayOutputStream();
        inImage.compress(Bitmap.CompressFormat.PNG, 100, bytes);
        String path = MediaStore.Images.Media.insertImage(inContext.getContentResolver(), inImage, "image", null);
        return Uri.parse(path);
    }

    private String getRealPathFromURI(Uri uri) {
        Cursor cursor = getContentResolver().query(uri, null, null, null, null);
        cursor.moveToFirst();
        int idx = cursor.getColumnIndex(MediaStore.Images.ImageColumns.DATA);
        return cursor.getString(idx);
    }


    private void preguntarPermisos() {
        // Versiones superiores de android con solicitud de permisos en tiempo de ejecución
        if (Build.VERSION.SDK_INT >= 23) {
            // Comprobar el estado del permiso que necesitamos
            int permisoEscritura = checkSelfPermission(android.Manifest.permission.WRITE_EXTERNAL_STORAGE);

            // Si no se tiene el permiso, según la acción se solicitará el permiso que neceistamos
            if (permisoEscritura != PackageManager.PERMISSION_GRANTED) {
                requestPermissions(new String[]{android.Manifest.permission.WRITE_EXTERNAL_STORAGE},
                        PERMISO_REQUEST_WRITE_EXTERNAL_STORAGE);
                // Si se tiene el permiso
            } else if (permisoEscritura == PackageManager.PERMISSION_GRANTED){
                compartirOtrasApps();
            }
            permisos = true;
        }
        else {
            permisos = true;
            compartirOtrasApps();
        }
    }


    @Override
    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        switch (requestCode) {

            case PERMISO_REQUEST_WRITE_EXTERNAL_STORAGE:
                // Si el permiso ha sido concedido, ejecutamos el método compartirOtrasApps
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    compartirOtrasApps();
                    permisos = true;

                } else { // Si no, informamos al usuario de la situación con un alert
                    Toast.makeText(this, getString(R.string.alerra_permiso_almacenamiento), Toast.LENGTH_SHORT).show();
                    permisos = false;
                }
                break;

        }
    }

    private void adjuntarImagen(Uri img) {
        Intent intent = new Intent();
        intent.setAction(Intent.ACTION_SEND);
        intent.putExtra(Intent.EXTRA_STREAM, img);

        String textoCompartir = getString(R.string.texto_compartir_disenio);
        intent.putExtra(Intent.EXTRA_TEXT, textoCompartir);

        intent.setType("image/*");

        // Generamos un selector con las aplicaciones disponibles para hacer el envío de información
        Intent chooser = Intent.createChooser(intent, "Compartir otras aplicaciones");
        if (intent.resolveActivity(getPackageManager()) != null) {
            startActivity(chooser);
        }
    }

}
