package currentweek.android.uoc.edu.aliapp;

import android.content.Context;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.RadioGroup;
import android.widget.Toast;

import model.AppConfig;
import model.SendMail;

import static currentweek.android.uoc.edu.aliapp.MainActivity.session;
import static model.AppConfig.medidasPermitidas;

public class DisenaTuJoyaPaso3 extends AppCompatActivity {


    private RadioGroup rgcol1;
    private RadioGroup rgcol2;
    private RadioGroup opcionesDiamantes;




    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_disena_joya_paso3);

        // habilitar el botón atrás
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        // Colocar título a la ventana
        getSupportActionBar().setTitle("Diseña tu joya. Diamantes III");

        rgcol1 = findViewById(R.id.rgcol1);
        rgcol2 = findViewById(R.id.rgcol2);
        opcionesDiamantes = findViewById(R.id.opcionesDiamantes);


        if (MedidorAlianzaActivity.alianza.getModelo() == "PIEZA UNICA") {
            // 1 material, ocultar columna 2
            rgcol2.setVisibility(View.INVISIBLE);

            // Seleccionar por defecto ninguno
            rgcol1.check(R.id.rb0diamante);
        }
        else {
            // más de 1 material, ocultar columna 1
            rgcol1.setVisibility(View.INVISIBLE);

            // Seleccionar por defecto ninguno
            rgcol2.check(R.id.rb0diamante);
        }

        MedidorAlianzaActivity.alianza.setNumDiamante(0);


        rgcol1.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {

            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {

                switch (checkedId) {
                    case R.id.rb0diamante:
                        MedidorAlianzaActivity.alianza.setNumDiamante(0);
                        break;

                    case R.id.rb1diamante:
                        MedidorAlianzaActivity.alianza.setNumDiamante(1);
                        break;

                    case R.id.rb3diamantes:
                        MedidorAlianzaActivity.alianza.setNumDiamante(3);
                        break;

                    case R.id.rb4diamante:
                        MedidorAlianzaActivity.alianza.setNumDiamante(4);
                        break;

                    case R.id.rb5diamante:
                        MedidorAlianzaActivity.alianza.setNumDiamante(5);
                        break;

                    case R.id.rb12diamante:
                        MedidorAlianzaActivity.alianza.setNumDiamante(12);
                        break;
                }
            }
        });


        rgcol2.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {

            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {

                switch (checkedId) {
                    case R.id.rb0diamantedoble:
                        MedidorAlianzaActivity.alianza.setNumDiamante(0);
                        break;

                    case R.id.rb3diamantesdoble:
                        MedidorAlianzaActivity.alianza.setNumDiamante(1);
                        break;

                    case R.id.rb5diamantedoble:
                        MedidorAlianzaActivity.alianza.setNumDiamante(3);
                        break;

                    case R.id.rb12diamantedoble:
                        MedidorAlianzaActivity.alianza.setNumDiamante(12);
                        break;
                }
            }
        });

    }




    public static Intent makeIntent(Context context) {
        return new Intent(context, DisenaTuJoyaPaso3.class);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_superior, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {
            case android.R.id.home: //hago un case por si en un futuro agrego mas opciones
                Log.i("ActionBar", "Atrás!");
                finish();
                return true;

            case R.id.action_settings:
                session.setLogin(false);
                Toast.makeText(this, R.string.cerrar_sesion, Toast.LENGTH_SHORT).show();
                Log.d("sesion", "Cerrando sesión...");

                Intent intent = MainActivity.makeIntent(this);
                startActivity(intent);
                finish();
                return true;

            case R.id.action_settings_favoritos:
                Log.d("favoritos", "Ver favoritos");

                Intent i = FavoritosActivity.makeIntent(this);
                startActivity(i);
                return true;

            case R.id.action_settings_home:
                Intent goHome = MainActivity.makeIntent(this);
                startActivity(goHome);
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }

    }



    public void mostrarTiendas(View view) {
        Intent intent = TiendasActivity.makeIntent(this);
        startActivity(intent);
    }



    public void solicitarPresupuesto(View view) {

        try {

            // Creamos texto del mensaje
            // Configuración de la alianza
            String contenidoMail = "<br> El usuario " + session.getUser() + " acaba de enviar una solicitud de presupuesto para una alianza. Las " +
                    "características que ha seleccionado son las siguientes: <br><br>" +
                    "NOMBRES ALIANZAS: <br>" +
                    "Nombre grabado 1: " + MedidorAlianzaActivity.alianza.getNombre1() +
                    "<br>Nombre grabado 2: " + MedidorAlianzaActivity.alianza.getNombre2() +
                    "<br><br>" +
                    "MEDIDA: " + medidasPermitidas[MedidorAlianzaActivity.alianza.getMedidaInd()] + "mm" +
                    "<br>MODELO: " + MedidorAlianzaActivity.alianza.getModelo() +
                    "<br>FORMA: " + MedidorAlianzaActivity.alianza.getForma() +
                    "<br>MATERIAL: " + MedidorAlianzaActivity.alianza.getMaterial() +
                    "<br>GROSOR: " + MedidorAlianzaActivity.alianza.getIndGrosor() +
                    "<br>ACABADO: " + MedidorAlianzaActivity.alianza.getAcabadoSelec() +
                    "<br>Número de diamantes: " + MedidorAlianzaActivity.alianza.getNumDiamante();

            // Datos del usuario
            contenidoMail += "<br><br><br> Los datos de contacto del usuario son los siguientes: <br>" +
                    "Nombre: " + session.getUser() + " (" + session.getMail() + " - " + session.getTel() + ") <br>" +
                    "Direccion: " + session.getUserDireccion() + ", " + session.getUserNumero() + ". <br>" +
                    "Edificio: " + session.getUserEd() + ". Puerta: " + session.getUserPuerta() + "<br>" +
                    "Municipio: " + session.getUserMunicipio() + " (" + session.getUserCP() + ")<br>";

            new SendMail(AppConfig.USER_MAIL, AppConfig.PASS_MAIL).execute(
                    new SendMail.Mail(AppConfig.USER_MAIL, AppConfig.USER_MAIL, getString(R.string.asunto_correo_presupuesto), contenidoMail)
            );

            Toast.makeText(this, "Ya se ha enviado su configuración. En unos días recibirá el presupuesto", Toast.LENGTH_LONG).show();

            MainActivity.fotoMail = false;

        } catch (Exception e) {
            Log.d("prob envio mail", e.toString());
        }
    }




}
