package currentweek.android.uoc.edu.aliapp;

import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.*;
import android.widget.*;

import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import model.AppConfig;
import model.AppController;
import model.PreguntaTest;
import model.TestNovios;

import static currentweek.android.uoc.edu.aliapp.MainActivity.session;

public class JuegaEnParejaActivity extends AppCompatActivity{

    private static final int NUM_PREGUNTAS_TOTAL = 6;
    private final String TAG = "Juega en pareja";

    private Context context;

    private int contadorpregunta;

    private TextView tituloPregunta;
    private RadioButton opt1;
    private RadioButton opt2;
    private RadioButton opt3;
    private RadioButton opt4;
    private RadioButton opt5;
    private RadioButton opt6;
    private RadioGroup opts;
    private Button btnNext;

    private String index_answer;
    private String index_answer_2;
    private String id_user_1;
    private String id_user_2;
    private String puntuation;
    private String puntuation_2;
    private String solutions;
    private int id_user1;
    private int id_user2;

    private String state;

    private String estado;
    private boolean seHaCreadoAhora = false;

    private List<String> resultadosObtenidos;
    private String resultadosObtenidosString;

    private int puntosTest;
    private List<PreguntaTest> listadoPreguntas;
    public static TestNovios nuevoTest;

    private boolean jugador1;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_juega_en_pareja);

        context = getApplicationContext();

        // habilitar el botón atrás
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        // Colocar título a la ventana
        getSupportActionBar().setTitle("Juega en pareja");

        tituloPregunta = findViewById(R.id.lblPregunta);
        opts = findViewById(R.id.opts);
        opt1 = findViewById(R.id.opt1);
        opt2 = findViewById(R.id.opt2);
        opt3 = findViewById(R.id.opt3);
        opt4 = findViewById(R.id.opt4);
        opt5 = findViewById(R.id.opt5);
        opt6 = findViewById(R.id.opt6);

        // Inicializar contador de pregunta
        contadorpregunta = 0;

        resultadosObtenidos = new ArrayList<String>();
        resultadosObtenidosString = "";

        btnNext = findViewById(R.id.btnNext);
        btnNext.setOnClickListener(new View.OnClickListener() {

            public void onClick(View view) {
                siguientePregunta();
            }
        });

        // Comprobar si existe test para este usuario
        comprobarTest();

    }



    public static Intent makeIntent(Context context) {
        return new Intent(context, JuegaEnParejaActivity.class);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_superior, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {
            case android.R.id.home: //hago un case por si en un futuro agrego mas opciones
                Log.i("ActionBar", "Atrás!");
                finish();
                return true;

            case R.id.action_settings:
                session.setLogin(false);
                Toast.makeText(this, R.string.cerrar_sesion, Toast.LENGTH_SHORT).show();
                Log.d("sesion", "Cerrando sesión...");

                Intent intent = MainActivity.makeIntent(this);
                startActivity(intent);
                finish();
                return true;

            case R.id.action_settings_favoritos:
                Log.d("favoritos", "Ver favoritos");

                Intent i = FavoritosActivity.makeIntent(this);
                startActivity(i);
                return true;

            case R.id.action_settings_home:
                Intent goHome = MainActivity.makeIntent(this);
                startActivity(goHome);
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }

    }



    private void comprobarTest() {
        String tag_string_req = "req_product";


        StringRequest strReq = new StringRequest(Request.Method.POST,
                AppConfig.URL_TEST, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {
                Log.d(TAG, "Test Response crear test: " + response.toString());

                JSONObject jObj = null;

                try {
                    jObj = new JSONObject(response);
                    obtenerInfoTest(jObj);
                } catch (JSONException e) {
                    e.printStackTrace();
                }

            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e(TAG, "Error al obtener productos: " + error.getMessage());

                crearNuevoTest();
                estado = "00";
            }
        }) {

            @Override
            protected Map<String, String> getParams() {
                // Posting parameters to login url
                Map<String, String> params = new HashMap<String, String>();
                params.put("usuario", session.getIdUser());

                return params;
            }

        };

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(strReq, tag_string_req);
    }



    private  void obtenerInfoTest(JSONObject jArray) {

        try{

                JSONObject json_data = jArray;

                // obtenemos todos los datos de la consulta
                index_answer = json_data.getString("index_answer");
                if (index_answer == "null")
                    index_answer = "";

                index_answer_2 = json_data.getString("index_answer_2");
                if (index_answer_2 == "null")
                    index_answer_2 = "";

                puntuation = json_data.getString("puntuation");
                if (puntuation == "null")
                    puntuation = "";

                puntuation_2 = json_data.getString("puntuation_2");
                if (puntuation_2 == "null")
                    puntuation_2 = "";

                solutions = json_data.getString("solutions");
                if (solutions == "null")
                    solutions = "";

                state = json_data.getString("state");
                if (state == "null")
                    state = "";

                id_user1 = json_data.getInt("id_user_1");

                id_user2 = json_data.getInt("id_user_2");


            // Averiguar si es jugador 1 o 2
            if (Integer.parseInt(session.getIdUser()) == id_user1)
                jugador1 = true;
            else
                jugador1 = false;

            // Averiguar el estado en el que está
            switch (state) {
                case "0":
                    estado = "00";
                    if (seHaCreadoAhora)
                        enviarResultados();
                    else
                        crearPreguntasNuevoTest();
                    break;

                case "1":
                    estado = "01";

                    if (jugador1) {
                        if(puntosTest > 0)
                            comprobarResultadosFinalizar();
                        else
                            mostrarDialogEmpezar();
                    }
                    else  // si es jugador dos, ya ha respondido al test y estará esperando
                        mostrarDialogEsperar();

                    break;

                case "10":
                    estado = state;
                    if (jugador1)
                        mostrarDialogEsperar();
                    else
                        mostrarDialogEmpezar();

                    break;

                case "11":
                    estado = state;
                    mostrarDialogEstado();

                    break;
            }


        } catch (Exception e) {
            e.printStackTrace();

            // Si no hay jugadores, es decir, dará error en los jugadores
            crearNuevoTest();
            estado = "00";

        }
    }



    private void comprobarResultadosFinalizar() {

        if(nuevoTest == null) {
            nuevoTest = new TestNovios();
        }

        int pts_1 = 0;
        int pts_2 = 0;

        if (jugador1){
            pts_1 = puntosTest;
            pts_2 = Integer.parseInt(puntuation_2);
        }
        else {
            pts_1 = Integer.parseInt(puntuation);
            pts_2 = puntosTest;
        }
        // Mostrar resultados
        String resultado = nuevoTest.comprobarResultados(pts_1, pts_2);

        enviarResultadosFinalizar(resultado);
    }
    private void mostrarDialogEmpezar(){
        AlertDialog.Builder builder = new AlertDialog.Builder(this);

        builder.setMessage("Tu pareja ya ha respondido al test, es tu turno")
                .setPositiveButton("Empezar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        crearPreguntasNuevoTest();
                    }
                })
                .setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        finish();
                    }
                });

        AlertDialog dialog = builder.create();
        dialog.show();
    }


    private void mostrarDialogError(){
        AlertDialog.Builder builder = new AlertDialog.Builder(this);

        builder.setMessage("Ha habido un error al enviar el test, debe hacerse de nuevo")
                .setPositiveButton("Empezar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        finish();
                    }
                })
                .setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        finish();
                    }
                });

        AlertDialog dialog = builder.create();
        dialog.show();
    }



    private void mostrarDialogEsperar() {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);

        builder.setMessage("Ya has respondido el test, es el turno de tu pareja")
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        finish();
                    }
                })
                .setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        finish();
                    }
                });

        AlertDialog dialog = builder.create();
        dialog.show();
    }



    private void mostrarDialogEstado(){
        AlertDialog.Builder builder = new AlertDialog.Builder(this);

        builder.setMessage("Ya han realizado el test")
                .setPositiveButton("Ver resultados", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        crearObjetoResultados();
                    }
                })
                .setNegativeButton("Empezar nuevo test", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        // Crear nuevo test en base de datos
                        crearNuevoTest();
                        estado = "00";
                    }
                });

        AlertDialog dialog = builder.create();
        dialog.show();
    }



    private void crearNuevoTest() {
        String tag_string_req = "req_nuevo_test";


        StringRequest strReq = new StringRequest(Request.Method.POST,
                AppConfig.URL_TEST, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {
                Log.d(TAG, "Test Creacion response: " + response.toString());
                if (response.toString().equals("1")) {
                    Log.d(TAG, "Se ha creado un nuevo test ");

                    crearPreguntasNuevoTest();
                }
            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e(TAG, "Error al obtener productos: " + error.getMessage());
                Toast.makeText(getApplicationContext(),
                        error.getMessage(), Toast.LENGTH_LONG).show();
            }
        }) {

            @Override
            protected Map<String, String> getParams() {
                // Posting parameters to login url
                Map<String, String> params = new HashMap<String, String>();
                params.put("usuario_nuevo", session.getIdUser());

                return params;
            }

        };

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(strReq, tag_string_req);
    }


    private void crearPreguntasNuevoTest() {
        puntosTest = 0;
        contadorpregunta = 0;
        nuevoTest = new TestNovios();

        // colocar datos en pregunta
        listadoPreguntas = nuevoTest.getTest();

        seHaCreadoAhora = true;

        cargarPregunta();


    }


    private  void cargarPregunta() {

        if (contadorpregunta < NUM_PREGUNTAS_TOTAL) {
            PreguntaTest actual = listadoPreguntas.get(contadorpregunta);

            tituloPregunta.setText(actual.getPregunta());

            opt1.setText(actual.getPosiblesRespuestas().get(0).getRespuesta());
            opt2.setText(actual.getPosiblesRespuestas().get(1).getRespuesta());
            opt3.setText(actual.getPosiblesRespuestas().get(2).getRespuesta());
            opt4.setText(actual.getPosiblesRespuestas().get(3).getRespuesta());
            opt5.setText(actual.getPosiblesRespuestas().get(4).getRespuesta());
            opt6.setText(actual.getPosiblesRespuestas().get(5).getRespuesta());

            // Desmarcar radio Buttons
            opts.clearCheck();
        }
        else {


            // Obtener un listado con las respuestas
            for (String resp:resultadosObtenidos) {
                resultadosObtenidosString += resp + ",";
            }

            switch (estado){
                case "01":
                    // Faltaba por responder el usuario actual
                    comprobarTest();
                    break;

                case "10":
                    if (!jugador1 && puntosTest > 0)
                        comprobarResultadosFinalizar();
                    break;

                case "00":
                    // Saber de qué jugador se trata para actualizar valores
                    comprobarTest();

                    break;
            }


        }
    }


    private void siguientePregunta(){

        if (contadorpregunta < NUM_PREGUNTAS_TOTAL) {
            // Recoger resultados
            int selectedId = opts.getCheckedRadioButtonId();
            boolean permitido = true;

            // Sumar resultados
            switch (selectedId) {

                case R.id.opt1:
                    puntosTest += listadoPreguntas.get(contadorpregunta).getPosiblesRespuestas().get(0).getPuntos();
                    // Añadimos el índice de la respuesta que se ha elegido
                    resultadosObtenidos.add("0");
                    break;

                case R.id.opt2:
                    puntosTest += listadoPreguntas.get(contadorpregunta).getPosiblesRespuestas().get(1).getPuntos();
                    // Añadimos el índice de la respuesta que se ha elegido
                    resultadosObtenidos.add("1");
                    break;

                case R.id.opt3:
                    puntosTest += listadoPreguntas.get(contadorpregunta).getPosiblesRespuestas().get(2).getPuntos();
                    // Añadimos el índice de la respuesta que se ha elegido
                    resultadosObtenidos.add("2");
                    break;

                case R.id.opt4:
                    puntosTest += listadoPreguntas.get(contadorpregunta).getPosiblesRespuestas().get(3).getPuntos();
                    // Añadimos el índice de la respuesta que se ha elegido
                    resultadosObtenidos.add("3");
                    break;

                case R.id.opt5:
                    puntosTest += listadoPreguntas.get(contadorpregunta).getPosiblesRespuestas().get(4).getPuntos();
                    // Añadimos el índice de la respuesta que se ha elegido
                    resultadosObtenidos.add("4");
                    break;

                case R.id.opt6:
                    puntosTest += listadoPreguntas.get(contadorpregunta).getPosiblesRespuestas().get(5).getPuntos();
                    // Añadimos el índice de la respuesta que se ha elegido
                    resultadosObtenidos.add("5");
                    break;

                default:
                    // Si no hay ninguna opción marcada, no debemos permitir continuar
                    permitido = false;
                    break;
            }

            if (permitido) {
                // Aumentar número de pregunta
                contadorpregunta++;
                Toast.makeText(this, contadorpregunta + " / " + NUM_PREGUNTAS_TOTAL, Toast.LENGTH_SHORT).show();
                cargarPregunta();

            } else
                Toast.makeText(this, "Se debe seleccionar una respuesta", Toast.LENGTH_SHORT).show();
        }

    }


    private void completarTestUsuarioActual() {
        // Enviar resultados


        // Obtener los puntos totales


        // Comprobar resultado
        String resultado = nuevoTest.comprobarResultados(puntosTest);

        if (resultado != null) {
            Intent intent = ResultadoTestActivity.makeIntent(this);
            startActivity(intent);
        }
        else {

            // Creamos un dialog de error para volver a comenzar el test en caso de error
            AlertDialog.Builder builder = new AlertDialog.Builder(this);
            builder.setTitle("Error en el test");
            builder.setMessage("Ha ocurrido un error al realizar el test, lo sentimos. Vuelva a realizarlo")
                    .setPositiveButton("Ok", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int id) {
                            Intent intent = JuegaEnParejaInfoActivity.makeIntent(context);
                            startActivity(intent);
                            finish();

                        }
                    })
                    .setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int id) {
                            Intent intent = AreaNoviosActivity.makeIntent(context);
                            startActivity(intent);
                            finish();
                        }
                    });


            AlertDialog dialog = builder.create();

        }
    }



    private void crearObjetoResultados() {
        if(nuevoTest == null) {
            nuevoTest = new TestNovios();
        }

        // Mostrar resultados
        String resultado = nuevoTest.comprobarResultados(Integer.parseInt(puntuation), Integer.parseInt(puntuation_2));

        mostrarResultado(resultado);

    }



    private void mostrarResultado(String resultado) {

        if (resultado != null) {
            Intent intent = ResultadoTestActivity.makeIntent(context);
            startActivity(intent);
        }
    }

    private void enviarResultados() {
        String tag_string_req = "req_send_results";


        StringRequest strReq = new StringRequest(Request.Method.POST,
                AppConfig.URL_TEST, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {
                Log.d(TAG, "Test Send Response: " + response.toString());

                if (response.equals("uno correcto") || response.equals("dos correcto"))
                    mostrarDialogEsperar();
                else
                    mostrarDialogError();

            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e(TAG, "Error al enviar resultados: " + error.getMessage());
                Toast.makeText(getApplicationContext(),
                        error.getMessage(), Toast.LENGTH_LONG).show();
            }
        }) {

            @Override
            protected Map<String, String> getParams() {
                // Posting parameters to login url
                Map<String, String> params = new HashMap<String, String>();
                params.put("usuario1", session.getIdUser());
                params.put("puntos_usuario", puntosTest + "");
                params.put("respuestas_usuario", resultadosObtenidosString);
                if(jugador1 && estado=="00")
                    params.put("estado", "10");
                if(!jugador1 && estado=="00")
                    params.put("estado", "01");

                return params;
            }

        };

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(strReq, tag_string_req);
    }



    private void enviarResultadosFinalizar(String res) {
        String tag_string_req = "req_send_results";


        StringRequest strReq = new StringRequest(Request.Method.POST,
                AppConfig.URL_TEST, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {
                Log.d(TAG, "Test Send Response: " + response.toString());

                if (response.equals("uno correcto final") || response.equals("dos correcto final"))
                    mostrarResultado("");
                else
                    mostrarDialogError();

            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e(TAG, "Error al enviar resultados: " + error.getMessage());
                Toast.makeText(getApplicationContext(),
                        error.getMessage(), Toast.LENGTH_LONG).show();
            }
        }) {

            @Override
            protected Map<String, String> getParams() {
                // Posting parameters to login url
                Map<String, String> params = new HashMap<String, String>();
                params.put("usuario1", session.getIdUser());
                params.put("puntos_usuario", puntosTest + "");
                params.put("respuestas_usuario", resultadosObtenidosString);
                params.put("resultados", nuevoTest.getIdProductosResultadosRespuestas());
                if(jugador1)
                    params.put("estado", "111");
                else
                    params.put("estado", "112");

                return params;
            }

        };

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(strReq, tag_string_req);
    }


    public void obtenerPuntosTotales() {

    }

}
