package currentweek.android.uoc.edu.aliapp;

import android.content.Context;
import android.content.Intent;
import android.content.res.Resources;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.util.TypedValue;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import model.Alianza;
import model.Lienzo;

import static currentweek.android.uoc.edu.aliapp.MainActivity.session;
import static model.AppConfig.medidasPermitidas;

public class MedidorAlianzaActivity extends AppCompatActivity {

    private RelativeLayout layoutAlianza;
    private Lienzo lienzoAnillo;

    private EditText nombre1;
    private EditText nombre2;
    private SeekBar size;
    private TextView lblSize;

    private int sizeAlianza;

    private Context context;

    public static Alianza alianza;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_medidor_alianza);


        layoutAlianza = findViewById(R.id.layoutAlianza);

        // habilitar el botón atrás
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        // Colocar título a la ventana
        getSupportActionBar().setTitle("Diseña tu joya. Medidor I");

        context = getApplicationContext();

        float dpActual = dp2px(context.getResources(), medidasPermitidas[0] / 2);

        lienzoAnillo = new Lienzo(this, dpActual);
        layoutAlianza.addView(lienzoAnillo);

        lblSize = findViewById(R.id.lblSizeMedidor);
        lblSize.setText("Tamaño: 8");
        size = findViewById(R.id.seekBarMedidor);

        nombre1 = findViewById(R.id.nombre1);
        nombre2 = findViewById(R.id.nombre2);

        nombre1.setSelected(false);
        nombre2.setSelected(false);


        size.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {

            int progress = 0;
            @Override
            public void onProgressChanged(SeekBar seekBar, int progresValue, boolean fromUser) {
                int siz = progresValue + 8;
                progress = siz;
                lblSize.setText(getString(R.string.lbl_size) + " " + siz);

                float dpActual = dp2px(context.getResources(), medidasPermitidas[progresValue] / 2);

                lienzoAnillo = new Lienzo(context, dpActual);
                layoutAlianza.addView(lienzoAnillo);

                if (progresValue == 26)
                    Toast.makeText(context, "No tenemos alianzas mayores. Lo sentimos", Toast.LENGTH_SHORT).show();

                sizeAlianza = progresValue;

            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
                lblSize.setText(getString(R.string.lbl_size) + " " +  progress);
            }

        });


        // creamos un objeto alianza, porque ya comenzó la configuración
        alianza = new Alianza();

    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_superior, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {
            case android.R.id.home: //hago un case por si en un futuro agrego mas opciones
                Log.i("ActionBar", "Atrás!");
                finish();
                return true;

            case R.id.action_settings:
                session.setLogin(false);
                Toast.makeText(this, R.string.cerrar_sesion, Toast.LENGTH_SHORT).show();
                Log.d("sesion", "Cerrando sesión...");

                Intent intent = MainActivity.makeIntent(this);
                startActivity(intent);
                finish();
                return true;

            case R.id.action_settings_favoritos:
                Log.d("favoritos", "Ver favoritos");

                Intent i = FavoritosActivity.makeIntent(this);
                startActivity(i);
                return true;

            case R.id.action_settings_home:
                Intent goHome = MainActivity.makeIntent(this);
                startActivity(goHome);
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }

    }



    public static float dp2px(Resources resource, float dp) {
        return TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP,   dp,resource.getDisplayMetrics());
    }


    public static Intent makeIntent(Context context) {
        return new Intent(context, MedidorAlianzaActivity.class);
    }



    public void irSegundoConfiguradorAlianza(View view) {
        // Obtener valores de nombre
        alianza.setNombre1(nombre1.getText().toString());
        alianza.setNombre2(nombre2.getText().toString());

        // Obtener medida de la alianza
        alianza.setMedida(medidasPermitidas[sizeAlianza]);
        alianza.setMedidaInd(sizeAlianza);

        Intent intent = DisenaTuJoyaPaso2.makeIntent(this);
        startActivity(intent);
    }


}
