package currentweek.android.uoc.edu.aliapp;

import android.content.Context;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import model.AppConfig;
import model.SendMail;


/*
* Esta clase permite recoger los datos de un nuevo usuario que desea registrarse
* en la aplicación. La app permitirá enviar un correo a los administradores con
* los datos de usuario.
* */
public class SolicitarUsuario extends AppCompatActivity {

    // Campos para recoger los datos de los nuevos usuarios
    private EditText mail;
    private EditText mail2;
    private EditText nombre;
    private EditText apellido1;
    private EditText apellido2;

    private EditText numTel;
    private EditText direccion;
    private EditText numero;
    private EditText edificio;
    private EditText puerta;
    private EditText municipio;
    private EditText cp;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_solicitar_usuario);

        // Definir los campos
        mail = findViewById(R.id.mailLogin);
        mail2 = findViewById(R.id.mail2Login);
        nombre = findViewById(R.id.nombreLogin);
        apellido1 = findViewById(R.id.apellido1Login);
        apellido2 = findViewById(R.id.apellido2Login);

        numTel = findViewById(R.id.telLogin);
        direccion = findViewById(R.id.direccionLogin);
        numero = findViewById(R.id.numeroLogin);
        edificio = findViewById(R.id.edificioLogin);
        puerta = findViewById(R.id.puertaLogin);
        municipio = findViewById(R.id.municipioLogin);
        cp = findViewById(R.id.cpLogin);


    }



    public static Intent makeIntent(Context context) {
        return new Intent(context, SolicitarUsuario.class);
    }



    /*
    * Este método recogerá los datos introducidos y los enviará al administrador para
    * notificarle de que existe un usuario que desea acceder a la app. El administrador
    * recibirá el correo que se compone y se envía y procederá al registro del usuario.
    * Para enviar el correo hacemos uso de la clase SendMail
    * */
    public void solicitarUsuario(View view) {
        MainActivity.fotoMail = false;

        // Crear correo con los datos recogidos
        String contenido = "Tiene una nueva solicitud de usuario: <br>" +
                "Nombre: " + nombre.getText() + " " + apellido1.getText() + " " + apellido2.getText() + "<br>" +
                "Mail: " + mail.getText() + " - asociado con " + mail2.getText() + "<br>" +
                "Teléfono: " + numTel.getText() + "<br><br>" +
                "Direccion: " + direccion.getText() + ", " + numero.getText() + ". <br>" +
                "Edificio: " + edificio.getText() + ". Puerta: " + puerta.getText() + "<br>" +
                "Municipio: " + municipio.getText() + " (" + cp.getText() + ")<br>";

        // Enviar correo con los datos
        new SendMail(AppConfig.USER_MAIL, AppConfig.PASS_MAIL).execute(
                new SendMail.Mail(AppConfig.USER_MAIL, AppConfig.USER_MAIL, "Notificación solicitud nuevo usuario", contenido)
        );

        Toast.makeText(this, "Se ha enviado la solicitud. Pronto nos pondremos en contacto contigo.", Toast.LENGTH_LONG).show();
    }
}
