package currentweek.android.uoc.edu.aliapp;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.view.menu.MenuView;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.*;
import android.widget.TextView;
import android.widget.Toast;

import java.util.Arrays;
import java.util.List;

import model.Tienda;

import static currentweek.android.uoc.edu.aliapp.MainActivity.session;

public class TiendasActivity extends AppCompatActivity {

    private String tipoLista;

    private RecyclerView recyclerView;
    private SimpleItemRecyclerViewAdapterTienda adapter = null;

    private List<Tienda> listaTiendas;

    private Context context;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tiendas);

        recyclerView = (RecyclerView) findViewById(R.id.listaTiendas);

        context = this.getApplicationContext();

        cargarTiendas();

        // Habilitar botón atrás barra
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        // Colocar título a la ventana
        getSupportActionBar().setTitle("Nuestras tiendas");

    }


    public static Intent makeIntent(Context context) {
        return new Intent(context, TiendasActivity.class);
    }

    private void cargarTiendas() {
        listaTiendas = Arrays.asList(new Tienda("922 26 27 19","C/ Obispo Rey Redondo (La Carrera), 49",  "La Laguna"),
                        new Tienda("922 262 719", "C/ Herradores, 57", "La Laguna"),
                        new Tienda("922 735 735","C.C. El Paso Local 4", "Las Chafiras"),
                        new Tienda("922 722 111","Ctra. General, 102", "Valle San Lorenzo"),
                        new Tienda("922 167 072","Ctra. General, 134", "San Miguel de Abona"));

        adapter = new SimpleItemRecyclerViewAdapterTienda(listaTiendas);
        RecyclerView.LayoutManager mLayoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(mLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.setAdapter(adapter);
    }



    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_superior, menu);

        return true;
    }


    @Override
    public boolean onPrepareOptionsMenu(Menu menu) {

        MenuItem btnSesion = menu.findItem(R.id.action_settings);
        btnSesion.setVisible(false);

        MenuItem btnFav = menu.findItem(R.id.action_settings_favoritos);
        btnFav.setVisible(false);

        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {
            case android.R.id.home: //hago un case por si en un futuro agrego mas opciones
                Log.i("ActionBar", "Atrás!");
                finish();
                return true;

            case R.id.action_settings_home:
                Intent goHome = MainActivity.makeIntent(this);
                startActivity(goHome);
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }

    }


    public class SimpleItemRecyclerViewAdapterTienda extends RecyclerView.Adapter<SimpleItemRecyclerViewAdapterTienda.ViewHolder> {

        private List<Tienda> mValues;


        public class ViewHolder extends RecyclerView.ViewHolder {
            // Views of each item of the list
            public View mView;
            public TextView mDireccion;
            public TextView mTelefono;
            public TextView mLocalizacion;


            /*
             * Constructor that defines the views
             * */
            public ViewHolder(View view) {
                super(view);

                mView = view;
                mDireccion = view.findViewById(R.id.lblTiendaDireccion);
                mTelefono = view.findViewById(R.id.lblPrecioFavorito);
                mLocalizacion = view.findViewById(R.id.lblTituloCatalogo);

            }

        }


        /*
         * Constructor that loads the list content
         * */
        public SimpleItemRecyclerViewAdapterTienda(List<Tienda> myDataset) {
            mValues = myDataset;
        }

        /*
         * We establish the model of each item of the list
         * */
        @NonNull
        @Override
        public SimpleItemRecyclerViewAdapterTienda.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

            View v = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_tiendas, parent, false);
            SimpleItemRecyclerViewAdapterTienda.ViewHolder vh = new SimpleItemRecyclerViewAdapterTienda.ViewHolder(v);

            return vh;

        }


        /*
         * In each item of the list, we upload the information of a follower
         * */
        @Override
        public void onBindViewHolder(@NonNull SimpleItemRecyclerViewAdapterTienda.ViewHolder holder, int position) {

            // Set different colors for even and odd cells
            if (position % 2 == 0)
                holder.mView.setBackgroundColor(Color.parseColor("#ffffff"));
            else
                holder.mView.setBackgroundColor(Color.parseColor("#ece6b6"));

            // Set follower info
            Tienda item = mValues.get(position);

            holder.mDireccion.setText(item.getDireccion());
            holder.mLocalizacion.setText(item.getLocalizacion());
            holder.mTelefono.setText(item.getTelefono());

        }

        @Override
        public int getItemCount() {
            return mValues.size();
        }

    }
}
