package model;

import android.os.AsyncTask;
import android.util.Log;

import java.util.Properties;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

import currentweek.android.uoc.edu.aliapp.DisenaTuJoyaPaso2;
import currentweek.android.uoc.edu.aliapp.MainActivity;

public class SendMail extends AsyncTask<SendMail.Mail,Void,Void> {


    private final String user;
    private final String pass;

    public SendMail(String user, String pass) {
        super();
        this.user = user;
        this.pass = pass;
    }

    @Override
    protected Void doInBackground(Mail... mails) {

        // Si hay que adjuntar imagene
        if (MainActivity.fotoMail) {

            try {

                // prepare session & transport object
                Properties props = new Properties();
                props.put("mail.transport.protocol", "smtps");
                props.put("mail.smtps.host", "smtp.gmail.com");
                props.put("mail.smtps.auth", "true");
                Session mailSession = Session.getDefaultInstance(props);
                mailSession.setDebug(true);
                Transport transport = mailSession.getTransport();


                for (Mail mail : mails) {

                    // prepare messge
                    MimeMessage message = new MimeMessage(mailSession);
                    message.setSubject(mail.subject);
                    message.addRecipient(Message.RecipientType.TO,
                            new InternetAddress(AppConfig.USER_MAIL));




                    // create multipart
                    Multipart multipart = new MimeMultipart();

                    // create bodypart with image and set content-id
                    MimeBodyPart messageBodyPart = new MimeBodyPart();

                    DataSource source = new FileDataSource(DisenaTuJoyaPaso2.finalFile);
                    messageBodyPart.setDataHandler(new DataHandler(source));
                    messageBodyPart.setFileName("image.jpg");

                    messageBodyPart.setDisposition(MimeBodyPart.INLINE);
                    messageBodyPart.setHeader("Content-ID", "<vogue>");
                    multipart.addBodyPart(messageBodyPart);

                    // create bodypart with html content and reference to the content-id
                    messageBodyPart = new MimeBodyPart();
                    String htmlText = mail.content + "<br><br><img src=\"cid:vogue\">";
                    messageBodyPart.setContent(htmlText, "text/html");
                    multipart.addBodyPart(messageBodyPart);


                    // add multipart to message
                    message.setContent(multipart);

                    //message.setText(mail.content);

                    // connect & send message
                    transport.connect
                            ("smtp.gmail.com", 465, AppConfig.USER_MAIL, AppConfig.PASS_MAIL);
                    transport.sendMessage(message,
                            message.getRecipients(Message.RecipientType.TO));
                    transport.close();
                }
            } catch (Exception e) {
                Log.d("SendMail - envio imagen", e.toString());
            }
        } else {
            Properties props = new Properties();
            props.put("mail.smtp.auth", "true");
            props.put("mail.smtp.starttls.enable", "true");
            props.put("mail.smtp.host", "smtp.gmail.com");
            props.put("mail.smtp.port", "25");

            Session session = Session.getInstance(props,
                    new javax.mail.Authenticator() {
                        protected PasswordAuthentication getPasswordAuthentication() {
                            return new PasswordAuthentication(user, pass);
                        }
                    });

            for (Mail mail : mails) {

                try {

                    Message message = new MimeMessage(session);
                    message.setFrom(new InternetAddress(mail.from));
                    message.setRecipients(Message.RecipientType.TO,
                            InternetAddress.parse(mail.to));
                    message.setSubject(mail.subject);
                    message.setText(mail.content);
                    message.setContent(mail.content, "text/html");

                    Transport.send(message);


                } catch (MessagingException e) {
                    Log.d("SendMail", e.getMessage());
                }
            }

        }
        return null;
    }



        public static class Mail{
            private final String subject;
            private final String content;
            private final String from;
            private final String to;

            public Mail(String from, String to, String subject, String content){
                this.subject=subject;
                this.content=content;
                this.from=from;
                this.to=to;
            }
        }

}
