package model;

import android.content.Context;
import android.content.SharedPreferences;
import android.util.Log;

import org.json.JSONException;
import org.json.JSONObject;

public class SessionManager {
    // LogCat tag
    private static String TAG = "sesionManager";

    // Shared Preferences
    SharedPreferences pref;

    SharedPreferences.Editor editor;
    Context _context;

    // Shared pref mode
    int PRIVATE_MODE = 0;

    // Shared preferences file name
    private static final String PREF_NAME = "AndroidHiveLogin";

    private static final String KEY_IS_LOGGED_IN = "isLoggedIn";

    public SessionManager(Context context) {
        this._context = context;
        pref = _context.getSharedPreferences(PREF_NAME, PRIVATE_MODE);
        editor = pref.edit();
    }

    public void setLogin(boolean isLoggedIn) {

        editor.putBoolean(KEY_IS_LOGGED_IN, isLoggedIn);

        // commit changes
        editor.commit();

        Log.d(TAG, "User login session modified!");
    }

    public void setUserData(JSONObject jObj) {
        try {
            String uid = jObj.getString("uid");

            JSONObject user = jObj.getJSONObject("user");

            editor.putString("id_usuario", uid);
            editor.putString("email", user.getString("email"));
            editor.putString("nombre", user.getString("name"));
            editor.putString("apellidos", user.getString("apellidos"));
            editor.putString("direccion", user.getString("adress"));
            editor.putString("ed", user.getString("ed"));
            editor.putString("puerta", user.getString("door"));
            editor.putString("numero", user.getString("number"));
            editor.putString("municipio", user.getString("municipio"));
            editor.putString("cp", user.getString("cp"));
            editor.putString("tel", user.getString("tel"));

            editor.commit();

        } catch (JSONException e) {
            e.printStackTrace();
            Log.d(TAG, e.getMessage());
        }
    }

    public boolean isLoggedIn(){
        return pref.getBoolean(KEY_IS_LOGGED_IN, false);
    }

    public String getUserDireccion(){
        return pref.getString("direccion", "");
    }

    public String getUserEd(){
        return pref.getString("ed", "");
    }

    public String getUserPuerta(){
        return pref.getString("puerta", "");
    }

    public String getUserNumero(){
        return pref.getString("numero", "");
    }

    public String getUserMunicipio(){
        return pref.getString("municipio", "");
    }

    public String getUserCP(){
        return pref.getString("cp", "");
    }

    public String getUser(){
        return pref.getString("nombre", "") + " " + pref.getString("apellidos", "");
    }

    public String getMail(){
        return pref.getString("email", "");
    }

    public String getTel(){
        return pref.getString("tel", "");
    }

    public String getIdUser(){
        return pref.getString("id_usuario", "");
    }


}