package model;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


/*
* En esta clase creamos las listas de respuestas posibles asociadas a cada pregunta de la
* lista que forma el test. Cada pregunta tiene asociada unos puntos. Finalmente, según los
* puntos obtenidos se tendrá una solución u otra. Cada solución, tiene asociada una serie
* de productos relacionada
* */
public class TestNovios {

    private List<PreguntaTest> test;

    private List<String> resultados = Arrays.asList(
            "\n" + "Con diamante\n" + "\n" + "Un anillo de compromiso con mucho estilo. Se aleja del tradicional solitario," +
                    " pues posee una combinación perfecta de elegancia, brillo y distinción. Perfectos para novias que sueñan" +
                    " con un enlace muy 'glam'.\n",

            "\n" + "Diferente y singular\n" + "\n" + "Un anillo para novias que quieren alejarse completamente de lo tradicional" +
                    " y buscan una pieza que refleje su estilo personal. Anillos con aro abierto o con formas irregulares son " +
                    "ideales para ellas.\n",

            "\n" + "Liso y sencillo\n" + "\n" + "Sin piedras o formas que sobresalgan o llamen la atención en los anillos de " +
                    "compromiso es lo que buscan algunas novias. Para ellas lo mejor será un aro liso con alguna piedra o detalle " +
                    "plano.\n",

            "\n" + "Piedra y toques de color\n" + "\n" + "Una joya que mezcla toques antiguos sin perder sofisticación. Ideal para" +
                    " novias que buscan detalles especiales y modernos.\n",

            "\n" + "Bohemio\n" + "\n" + "Para novias que se decantan por los detalles naturales y joyas muy originales." +
                    " Por lo general, son piezas que incluyen alguna flor o rama con pedrería.\n");

    private List<List<Producto>> listaResultadosProductos = new ArrayList<List<Producto>>();

    private String resultadoDefinitivo = null;

    private List<Producto> listaProductosDefinitivos = new ArrayList<Producto>();

    private List<String> idProductosRespuestas = new ArrayList<String>();
    private String idProductosResultadosRespuestas = "";



    public TestNovios() {

        // Definimos las respuestas de cada una de las preguntas con la asignación de puntos correspondientes
        List<RespuestaTest> posRespuestas1 = new ArrayList<RespuestaTest>();
        posRespuestas1.add(new RespuestaTest("Tradicional", 2));
        posRespuestas1.add(new RespuestaTest("Colorido", 3));
        posRespuestas1.add(new RespuestaTest("Silvestre", 4));
        posRespuestas1.add(new RespuestaTest("Sencillo", 5));
        posRespuestas1.add(new RespuestaTest("Flores Naturales", 6));
        posRespuestas1.add(new RespuestaTest("Romántica", 7));


        List<RespuestaTest> posRespuestas2 = new ArrayList<RespuestaTest>();
        posRespuestas2.add(new RespuestaTest("Corte Sirena", 2));
        posRespuestas2.add(new RespuestaTest("Princesa", 3));
        posRespuestas2.add(new RespuestaTest("Algo diferente", 4));
        posRespuestas2.add(new RespuestaTest("Con volumen pero sin exagerar", 5));
        posRespuestas2.add(new RespuestaTest("Corte imperio", 6));
        posRespuestas2.add(new RespuestaTest("De corte recto", 7));


        List<RespuestaTest> posRespuestas3 = new ArrayList<RespuestaTest>();
        posRespuestas3.add(new RespuestaTest("En una cita un fin de semana", 2));
        posRespuestas3.add(new RespuestaTest("Mientras paseabamos", 3));
        posRespuestas3.add(new RespuestaTest("Por la noche en una cena romántica", 4));
        posRespuestas3.add(new RespuestaTest("Mientras practicábamos nuestra actividad deportiva favorita", 5));
        posRespuestas3.add(new RespuestaTest("En un lugar especial para nosotros", 6));
        posRespuestas3.add(new RespuestaTest("Una sorpresa con amigos y familiares", 7));


        List<RespuestaTest> posRespuestas4 = new ArrayList<RespuestaTest>();
        posRespuestas4.add(new RespuestaTest("Tacón y punta descubierta", 2));
        posRespuestas4.add(new RespuestaTest("Tacón tradicional cerrado", 3));
        posRespuestas4.add(new RespuestaTest("De color", 4));
        posRespuestas4.add(new RespuestaTest("Sandalias", 5));
        posRespuestas4.add(new RespuestaTest("Con algún detalle novedoso", 6));
        posRespuestas4.add(new RespuestaTest("Unas cuñas", 7));


        List<RespuestaTest> posRespuestas5 = new ArrayList<RespuestaTest>();
        posRespuestas5.add(new RespuestaTest("Algo novedoso, una fiesta organizada de manera personalizada", 2));
        posRespuestas5.add(new RespuestaTest("Clásico, formal y elegante", 3));
        posRespuestas5.add(new RespuestaTest("Rústico", 4));
        posRespuestas5.add(new RespuestaTest("Vintage", 5));
        posRespuestas5.add(new RespuestaTest("Un banquete original", 6));
        posRespuestas5.add(new RespuestaTest("Una fiesta, pero lo más importante es que haya espacio suficiente para la familia y los amigos", 7));


        List<RespuestaTest> posRespuestas6 = new ArrayList<RespuestaTest>();
        posRespuestas6.add(new RespuestaTest("A la moda, me gusta llevas las últimas tendencias", 2));
        posRespuestas6.add(new RespuestaTest("Clásico y formal", 3));
        posRespuestas6.add(new RespuestaTest("Algo diferente a lo común, tengo un estilo muy personal", 4));
        posRespuestas6.add(new RespuestaTest("Prendas básicas con elementos de moda", 5));
        posRespuestas6.add(new RespuestaTest("Informal", 6));
        posRespuestas6.add(new RespuestaTest("Las tiendas de segunda mano son una muy buena opción", 7));


        // Generamos el test asignando una pregunta y las posibles respuestas a la pregunta en cuestión
        test = Arrays.asList(new PreguntaTest("¿Cómo te gustaría que fuera el ramo de la novia?",  posRespuestas1),
                             new PreguntaTest("¿Cómo te imaginas el vestido de novia?",  posRespuestas2),
                             new PreguntaTest("¿En qué lugar ha sido la pedida?",  posRespuestas3),
                             new PreguntaTest("¿Qué zapatos de novia crees que pegan más con el vestido que tienes en mente?",  posRespuestas4),
                             new PreguntaTest("¿Con qué estilo identificas tu ceremonia ideal?",  posRespuestas5),
                             new PreguntaTest("¿Cómo sueles vestir habitaulmente?",  posRespuestas6)
        );


        // Creamos las listas de productos específicos
        List<Producto> productos1 = new ArrayList<Producto>();
        productos1.add(new Producto("6", "ANILLOS DE COMPROMISO ORO BLANCO DIAMANTES - VS2 H", "905.00", "ANILLOS DE COMPROMISO ORO BLANCO DIAMANTES - VS2 H",
                "alianza", "https://joyeriasadeley.com/4314-thickbox_default/1.jpg", "ORO BLANCO", "12", "28", "",
                "JDL1-90067-20-9", "https://joyeriasadeley.com/joyas/anillos-de-compromiso-oro-blanco-diamantes-vs2-h-jdl1-90067-20-9-2916"));

        productos1.add(new Producto("7", "ANILLOS DE COMPROMISO ORO BLANCO DIAMANTES - VS2 H", "700.00", "ANILLOS DE COMPROMISO ORO BLANCO DIAMANTES - VS2 H",
                "alianza", "https://joyeriasadeley.com/4313-thickbox_default/1.jpg", "ORO BLANCO", "12", "21", "",
                "JDL1569/17-35", "https://joyeriasadeley.com/joyas/anillos-de-compromiso-oro-blanco-diamantes-vs2-h-jdl1569-17-35-2915"));

        productos1.add(new Producto("8", "ANILLOS DE COMPROMISO ORO BLANCO TRES DIAMANTES", "2516.00", "ANILLOS DE COMPROMISO ORO BLANCO TRES DIAMANTES",
                "alianza", "https://joyeriasadeley.com/4319-thickbox_default/1.jpg", "ORO BLANCO", "12", "20", "", "JDL0/S-1118-1",
                "https://joyeriasadeley.com/joyas/anillos-de-compromiso-oro-blanco-diamantes-jdl0-s-1118-1-2921"));

        idProductosRespuestas.add("6,7,8");


        List<Producto> productos2 = new ArrayList<Producto>();
        productos2.add(new Producto("9", "ALIANZAS ORO AMARILLO", "360.33", "ALIANZAS ORO AMARILLO - 3,5 MM", "alianza",
                "https://joyeriasadeley.com/18121-thickbox_default/1.jpg", "ORO AMARILLO", "12", "21", "",
                "DP501-BRI/W12", "https://joyeriasadeley.com/joyas/alianzas-oro-amarillo-n-12-35-mm-dp501-bri-w12-5826"));

        productos2.add(new Producto("10", "ALIANZAS ORO ROSA 10 DIAMANTE", "481.00", "ALIANZAS ORO ROSA 10 DIAMANTE", "alianza",
                "https://joyeriasadeley.com/17573-thickbox_default/1.jpg", "ORO BICOLOR", "13", "22", "", "DP608RD/W10",
                "https://joyeriasadeley.com/joyas/alianzas-oro-rosa-n-10-diamantes-dp608rd-w10-3016"));

        productos2.add(new Producto("11", "ALIANZAS ORO BICOLOR", "546.00", "ALIANZAS ORO BICOLOR - 10 - 6mm", "alianza",
                "https://joyeriasadeley.com/17602-thickbox_default/1.jpg", "ORO BICOLOR", "12", "18", "", "DP016A/W10",
                "https://joyeriasadeley.com/joyas/alianzas-oro-bicolor-n-10-6-mm-dp016a-w10-3675"));

        idProductosRespuestas.add("9,10,11");


        List<Producto> productos3 = new ArrayList<Producto>();
        productos3.add(new Producto("12", "ALIANZAS ORO AMARILLO", "148.80", "ALIANZAS ORO AMARILLO - 8 - 3mm", "alianza",
                "https://joyeriasadeley.com/17556-thickbox_default/1.jpg", "ORO AMARILLO", "13", "23", "", "0003/W8",
                "https://joyeriasadeley.com/joyas/alianzas-oro-amarillo-n-8-3mm-0003-w8-3036"));

        productos3.add(new Producto("13", "ALIANZAS ORO BLANCO", "346.00", "ALIANZAS ORO BLANCO - 10 - 5mm", "alianza",
                "https://joyeriasadeley.com/17591-thickbox_default/1.jpg", "ORO BLANCO", "13", "23", "", "DP250B/W10",
                "https://joyeriasadeley.com/joyas/alianzas-oro-blanco-n-10-gr-5-mm-dp250b-w10-3668"));

        productos3.add(new Producto("14", "ALIANZAS ORO AMARILLO", "238.00", "ALIANZAS ORO AMARILLO - 8 - 3.5mm", "alianza",
                "https://joyeriasadeley.com/18586-thickbox_default/1.jpg", "ORO AMARILLO", "8", "33", "", "0074/W8",
                "https://joyeriasadeley.com/joyas/alianzas-oro-amarillo-n-8-35mm-0074-w8-5908"));

        idProductosRespuestas.add("12,13,14");


        List<Producto> productos4 = new ArrayList<Producto>();
        productos4.add(new Producto("15", "ALIANZAS ORO BLANCO", "468.00", "ALIANZAS ORO BLANCO - 10 - 4mm", "alianza",
                "https://joyeriasadeley.com/17610-thickbox_default/1.jpg", "ORO BLANCO", "10", "28", "", "DP245B-B/W",
                "https://joyeriasadeley.com/joyas/alianzas-oro-blanco-n-10-4-mm-dp245b-b-w-5142"));

        productos4.add(new Producto("16", "ALIANZAS ORO ROSA", "575.00", "ALIANZAS ORO ROSA - 10 - 6mm", "alianza",
                "https://joyeriasadeley.com/17583-thickbox_default/1.jpg", "ORO BICOLOR", "10", "28", "", "DP927R/W10",
                "https://joyeriasadeley.com/joyas/alianzas-oro-rosa-n-10-6-mm-dp927r-w10-3013"));

        productos4.add(new Producto("17", "ALIANZAS ORO BICOLOR", "485.65", "ALIANZAS ORO BICOLOR - 10 - 5mm", "alianza",
                "https://joyeriasadeley.com/17599-thickbox_default/1.jpg", "ORO BICOLOR", "10", "28", "", "DP951/W10",
                "https://joyeriasadeley.com/joyas/alianzas-oro-bicolor-n-10-5-mm-dp951-w10-3685#/65-tamano-10"));

        idProductosRespuestas.add("15,16,17");


        List<Producto> productos5 = new ArrayList<Producto>();
        productos5.add(new Producto("18", "ALIANZAS ORO BICOLOR", "232.50", "ALIANZAS ORO BICOLOR - 8 - 4mm", "alianza",
                "https://joyeriasadeley.com/17568-thickbox_default/1.jpg", "ORO BICOLOR", "8", "33", "", "4296/W8",
                "https://joyeriasadeley.com/joyas/alianzas-oro-bicolor-n-8-4mm-4296-w8-3037"));

        productos5.add(new Producto("19", "ALIANZAS ORO AMARILLO", "226.90", "ALIANZAS ORO AMARILLO - 8 - 4mm", "alianza",
                "https://joyeriasadeley.com/17579-thickbox_default/1.jpg", "ORO AMARILLO", "8", "33", "", "4108/W8",
                "https://joyeriasadeley.com/joyas/alianzas-oro-amarillo-n-8-4mm-4108-w8-3039"));

        productos5.add(new Producto("20", "ALIANZAS ORO AMARILLO", "296.65", "ALIANZAS ORO AMARILLO - 8 - 4mm", "alianza",
                "https://joyeriasadeley.com/17566-thickbox_default/1.jpg", "ORO AMARILLO", "8", "33", "", "3266/W8",
                "https://joyeriasadeley.com/joyas/alianzas-oro-amarillo-n-8-4mm-3266-w8-3033"));

        idProductosRespuestas.add("18,19,20");



        // Cargamos las posibles listas de productos
        listaResultadosProductos.add(productos1);
        listaResultadosProductos.add(productos2);
        listaResultadosProductos.add(productos3);
        listaResultadosProductos.add(productos4);
        listaResultadosProductos.add(productos5);

    }



    private static boolean isBetween(int x, int lower, int upper) {
        return lower <= x && x <= upper;
    }

    public String comprobarResultados(int puntosTest) {
        // Hay 31 posibilidades posibles de puntos (12 - 42)
        // obtener puntos totales / periodo de salto
        if (isBetween(puntosTest, 24, 35)) {
            resultadoDefinitivo = resultados.get(0);
            // Cargar la lista de los productos
            listaProductosDefinitivos = listaResultadosProductos.get(0);
            idProductosResultadosRespuestas = idProductosRespuestas.get(0);
            return resultadoDefinitivo;
        } else {
            if (isBetween(puntosTest, 36, 47)){
                resultadoDefinitivo = resultados.get(1);
                // Cargar la lista de los productos
                listaProductosDefinitivos = listaResultadosProductos.get(1);
                idProductosResultadosRespuestas = idProductosRespuestas.get(1);
                return resultadoDefinitivo;
            }
            else {
                if (isBetween(puntosTest, 48, 59)){
                    resultadoDefinitivo = resultados.get(2);
                    // Cargar la lista de los productos
                    listaProductosDefinitivos = listaResultadosProductos.get(2);
                    idProductosResultadosRespuestas = idProductosRespuestas.get(2);
                    return resultadoDefinitivo;
                }
                else {
                    if (isBetween(puntosTest, 60, 71)) {
                        resultadoDefinitivo = resultados.get(3);
                        // Cargar la lista de los productos
                        listaProductosDefinitivos = listaResultadosProductos.get(3);
                        idProductosResultadosRespuestas = idProductosRespuestas.get(3);
                        return resultadoDefinitivo;
                    }
                    else {
                        if (isBetween(puntosTest, 72, 84)){
                            resultadoDefinitivo = resultados.get(4);
                            idProductosResultadosRespuestas = idProductosRespuestas.get(4);
                            // Cargar la lista de los productos
                            listaProductosDefinitivos = listaResultadosProductos.get(4);
                            return resultadoDefinitivo;
                        }
                        return null;
                    }
                }
            }
        }
    }


    public String comprobarResultados(int puntosJug1, int puntosJug2) {
        return  comprobarResultados(puntosJug1 + puntosJug2);
    }

    /* Getter */
    public List<PreguntaTest> getTest() {
        return test;
    }

    public List<String> getResultados() {
        return resultados;
    }

    public String getResultadoDefinitivo() {
        return resultadoDefinitivo;
    }

    public String getIdProductosResultadosRespuestas() {
        return idProductosResultadosRespuestas;
    }

    public List<Producto> getListaProductosDefinitivos() {
        return listaProductosDefinitivos;
    }

}
